﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics;

namespace TestProject
{
	public class DataItemBase : PropertyChangeNotifier
	{
		protected bool SetField<T>(ref T member, T newValue, string propertyName)
		{
			if (EqualityComparer<T>.Default.Equals(member, newValue))
				return false;

			member = newValue;
			this.OnPropertyChanged(propertyName);
			return true;
		}
	}

	public class ResourceItem : DataItemBase
	{
		private string _id;
		public string Id
		{
			get { return _id; }
			set { this.SetField(ref _id, value, "Id"); }
		}

		private string _name;
		public string Name
		{
			get { return _name; }
			set { this.SetField(ref _name, value, "Name"); }
		}
	}

	public class ResourceCalendarItem : DataItemBase
	{
		private string _id;
		public string Id
		{
			get { return _id; }
			set { this.SetField(ref _id, value, "Id"); }
		}

		private string _name;
		public string Name
		{
			get { return _name; }
			set { this.SetField(ref _name, value, "Name"); }
		}

		private string _owningResourceOwningResourceId;
		public string OwningResourceId
		{
			get { return _owningResourceOwningResourceId; }
			set { this.SetField(ref _owningResourceOwningResourceId, value, "OwningResourceId"); }
		}
	}

	public class ActivityItem : DataItemBase
	{
		private string _id;
		public string Id
		{
			get { return _id; }
			set { this.SetField(ref _id, value, "Id"); }
		}

		private string _description;
		public string Description
		{
			get { return _description; }
			set { this.SetField(ref _description, value, "Description"); }
		}

		private DateTime _start;
		public DateTime Start
		{
			get { return _start; }
			set { this.SetField(ref _start, value, "Start"); }
		}

		private DateTime _end;
		public DateTime End
		{
			get { return _end; }
			set { this.SetField(ref _end, value, "End"); }
		}

		private string _owningResourceId;
		public string OwningResourceId
		{
			get { return _owningResourceId; }
			set { this.SetField(ref _owningResourceId, value, "OwningResourceId"); }
		}

		private string _owningCalendarId;
		public string OwningCalendarId
		{
			get { return _owningCalendarId; }
			set { this.SetField(ref _owningCalendarId, value, "OwningCalendarId"); }
		}
	}

	public class AppointmentItem : ActivityItem
	{
		private string _subject;
		public string Subject
		{
			get { return _subject; }
			set { this.SetField(ref _subject, value, "Subject"); }
		}
	}
}
